package org.example.convertidordivisas2;

import android.content.Intent;
import android.content.SharedPreferences;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.StrictMode;
import android.preference.PreferenceManager;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import java.net.URL;
import java.net.URLEncoder;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 * Created by jaci on 18/11/2015.
 */
public class Convertidor extends ActionBarActivity implements View.OnClickListener{

    private TextView pantalla;
    //inicializamos variables para url del webservicex
    String monedaOrigen = "EUR", monedaDestino = "USD";
    Double ratio;//lo k nos devuelve el servicio
    //varibles de control eventos teclado
    boolean decimal = false;
    boolean limpia = false;
    boolean okResul = false;

    Double num;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.convertidor);
        //inicializamos pantalla
        pantalla = (TextView)findViewById(R.id.texto);
        //inicializamos teclado
        Button n0 = (Button)findViewById(R.id.btn0);
        n0.setOnClickListener(this);
        Button n1 = (Button)findViewById(R.id.btn1);
        n1.setOnClickListener(this);
        Button n2 = (Button)findViewById(R.id.btn2);
        n2.setOnClickListener(this);
        Button n3 = (Button)findViewById(R.id.btn3);
        n3.setOnClickListener(this);
        Button n4 = (Button)findViewById(R.id.btn4);
        n4.setOnClickListener(this);
        Button n5 = (Button)findViewById(R.id.btn5);
        n5.setOnClickListener(this);
        Button n6 = (Button)findViewById(R.id.btn6);
        n6.setOnClickListener(this);
        Button n7 = (Button)findViewById(R.id.btn7);
        n7.setOnClickListener(this);
        Button n8 = (Button)findViewById(R.id.btn8);
        n8.setOnClickListener(this);
        Button n9 = (Button)findViewById(R.id.btn9);
        n9.setOnClickListener(this);
        Button punto = (Button)findViewById(R.id.btnPunto);
        punto.setOnClickListener(this);

        Button ptas = (Button)findViewById(R.id.btnConvert);
        ptas.setOnClickListener(this);
        Button acero = (Button)findViewById(R.id.btnAcero);
        acero.setOnClickListener(this);
        Button del = (Button)findViewById(R.id.btnDel);
        del.setOnClickListener(this);

        //permiso del StrictMode para acceder a internet desde la pantalla de usuario
        StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().permitNetwork().build());
    }

    //nos devolvera el ratio
    Double resultadosSW(Double ratio) throws Exception {
        // creamos la URL de la conexion URLencoder codifica las palabras en formato para servidor
        URL url = new URL("http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate?FromCurrency="
                + URLEncoder.encode(monedaOrigen, "UTF-8")  + "&ToCurrency="+ URLEncoder.encode(monedaDestino , "UTF-8") );
        //usamos las librerias org.xml.sax para hacer Parser sobre el codigo XML de la URL
        SAXParserFactory fabrica = SAXParserFactory.newInstance();
        SAXParser parser = fabrica.newSAXParser();
        XMLReader lector = parser.getXMLReader();
        //XMLHandler
        ManejadorXML manejadorXML = new ManejadorXML();
        lector.setContentHandler(manejadorXML);
        lector.parse(new InputSource(url.openStream()));
        //getTotalResults no devuelve la informacion k nos interesa
        return manejadorXML.getTotalResults();
    }

    //teclado
    @Override
    public void onClick(View view) {


        int select =view.getId();
        String borra;

        String a = pantalla.getText().toString();


        try {
            switch (select) {
                case R.id.btn0:
                    //accion
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "0");
                    break;
                case R.id.btn1:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "1");
                    break;
                case R.id.btn2:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "2");
                    break;
                case R.id.btn3:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "3");
                    break;
                case R.id.btn4:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "4");
                    break;
                case R.id.btn5:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "5");
                    break;
                case R.id.btn6:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "6");
                    break;
                case R.id.btn7:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "7");
                    break;
                case R.id.btn8:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "8");
                    break;
                case R.id.btn9:
                    if(limpia == true){
                        return;
                    }else
                        pantalla.setText(a + "9");
                    break;
                case R.id.btnPunto:

                    if(limpia == true){
                        return;
                    }else if (decimal == false) {
                        pantalla.setText(a + ".");
                        decimal = true;
                    }else { return;
                    }
                    break;
                case R.id.btnDel:
                    if (a.length() == 0 || okResul == true) {
                        return;
                    } else
                        borra = a.substring(0, a.length() - 1);
                    a = borra;
                    pantalla.setText(String.valueOf(a));
                    limpia = false;
                    break;

                case R.id.btnConvert:
                    if (a.length() == 0) {
                        return;
                    } else if(okResul == false)
                        num = Double.parseDouble(a);
                    //pantalla.setText(String.valueOf( resultado + "ptas"));
                    buscar(num);
                    limpia = true;
                    break;
                case R.id.btnAcero:
                    pantalla.setText("");
                    decimal = false;
                    limpia = false;
                    okResul = false;//cuando el resultado esta en pantalla desbloqueo desde aki
                    break;
            }
        }catch(Exception e){
            pantalla.setText("ERROR");
        }
    }


    // metodo k se llama con el onClick del boton  "convertir"
    public void buscar(Double num) {
        num = this.num ;

        try {
            Double resultado = num * resultadosSW(ratio);
            Double resultado2 = Math.rint(resultado*100)/100;
            pantalla.setText(num + "-" + monedaOrigen + " \n" + resultado2 + "-" + monedaDestino + "\n");
            okResul = true;// resultado en pantalla para anular del
        } catch (Exception e) {
            pantalla.setText("Error al conectar\n");
            Log.e("HTTP", e.getMessage(), e);
        }
    }

    //menu
    @Override public boolean onCreateOptionsMenu(Menu menu){
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }
    @Override public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();

        if (id == R.id.action_settings) {
            lanzarPreferencias(null);
            return true;
        }

        if (id == R.id.acercaDe) {
            lanzarAcercaDe(null);
            return true;
        }

        if (id == R.id.listaDe) {
            lanzarListado(null);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }
    //llamadas a actividades
    public void lanzarPreferencias(View view) {
        Intent i =new Intent(this, Preferencias.class);
        startActivity(i);
    }

    public void lanzarAcercaDe(View view){
        Intent i = new Intent(this, AcercaDe.class);
        startActivity(i);
    }

    public void lanzarListado(View view){
        String envio = monedaOrigen;
        Intent i = new Intent(this, Listado.class);
        i.putExtra("m", envio);
        startActivity(i);
    }


    @Override protected void onResume() {
        super.onResume();
        //parece k si no lo incluyo aki no refresca la seleccion
        SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);

        if (pref.getString("moneda1", "EUR").equals("AUD")) {
            monedaOrigen = "AUD";
        } else if (pref.getString("moneda1", "EUR").equals("BRL")) {
            monedaOrigen = "BRL";
        } else if (pref.getString("moneda1", "EUR").equals("GBP")) {
            monedaOrigen = "GBP";
        } else if (pref.getString("moneda1", "EUR").equals("CAD")) {
            monedaOrigen = "CAD";
        } else if (pref.getString("moneda1", "EUR").equals("CNY")) {
            monedaOrigen = "CNY";
        } else if (pref.getString("moneda1", "EUR").equals("EUR")) {
            monedaOrigen = "EUR";
        } else if (pref.getString("moneda1", "EUR").equals("HKD")) {
            monedaOrigen = "HKD";
        } else if (pref.getString("moneda1", "EUR").equals("JPY")) {
            monedaOrigen = "JPY";
        } else if (pref.getString("moneda1", "EUR").equals("RUB")) {
            monedaOrigen = "RUB";
        } else if (pref.getString("moneda1", "EUR").equals("USD")) {
            monedaOrigen = "USD";
        }
        //elegimos moneda al cambio
        if (pref.getString("moneda2", "USD").equals("AUD")) {
            monedaDestino = "AUD";
        } else if (pref.getString("moneda2", "USD").equals("BRL")) {
            monedaDestino = "BRL";
        } else if (pref.getString("moneda2", "USD").equals("GBP")) {
            monedaDestino = "GBP";
        } else if (pref.getString("moneda2", "USD").equals("CAD")) {
            monedaDestino = "CAD";
        } else if (pref.getString("moneda2", "USD").equals("CNY")) {
            monedaDestino = "CNY";
        } else if (pref.getString("moneda2", "USD").equals("EUR")) {
            monedaDestino = "EUR";
        } else if (pref.getString("moneda2", "USD").equals("HKD")) {
            monedaDestino = "HKD";
        } else if (pref.getString("moneda2", "USD").equals("JPY")) {
            monedaDestino = "JPY";
        } else if (pref.getString("moneda2", "USD").equals("RUB")) {
            monedaDestino = "RUB";
        } else if (pref.getString("moneda2", "USD").equals("USD")) {
            monedaDestino = "USD";
        }
    }



    @Override protected void onPause() {

        //Toast. makeText(this, "onPause", Toast.LENGTH_SHORT).show();
        super.onPause();
    }

    @Override
    protected void onStop(){
        //Toast. makeText(this, "onStop", Toast.LENGTH_SHORT).show();
        super.onStop();
    }

    @Override
    protected void onDestroy() {
        //Toast. makeText(this, "onDestroy", Toast.LENGTH_SHORT).show();
        super.onDestroy();
    }

    //guardar estado pantalla

    String b;
    boolean decimal2;
    @Override protected void onSaveInstanceState(Bundle guardarEstado) {
        super.onSaveInstanceState(guardarEstado);
        b = pantalla.getText().toString();
        decimal2 = decimal;
        guardarEstado.putString("pantalla", b);
        guardarEstado.putBoolean("punto", decimal2);
    }
    @Override protected void onRestoreInstanceState(Bundle recEstado) {

        super.onRestoreInstanceState(recEstado);
        if (recEstado != null)
            b = recEstado.getString("pantalla");
        decimal2 = recEstado.getBoolean("punto");
        pantalla.setText(b);
        decimal = decimal2;

    }


}
