package org.example.convertidordivisas2;

/**
 * Created by jaci on 13/11/2015.
 */

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**clase creada para manejar el archivo XML*/
public class ManejadorXML extends DefaultHandler {

    private Double totalResults;//almacena el resultado
    private StringBuilder cadena = new StringBuilder();//para manejar la info del XML

    public double getTotalResults() {
        //devuelve el cambio
        return totalResults;
    }


    //inicializamos la variable cadena cada vez k empieza una etiqueta
    @Override
    public void startElement(String uri, String nombreLocal, String nombreCualif, Attributes atributos) throws SAXException {
        cadena.setLength(0);
    }


    @Override
    public void characters(char ch[], int comienzo, int lon) {
        cadena.append(ch, comienzo, lon);
    }


    @Override
    public void endElement(String uri, String nombreLocal, String nombreCualif) throws SAXException {
        //convertimos a Double el valor de cadena
        totalResults = Double.parseDouble(cadena.toString());
    }
}
